// nstest.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "nstest.h"

#include "mainfrm.h"
#include "ipframe.h"
#include "nstesdoc.h"
#include "nstesvw.h"

#include "ddeobj.h"
#include "registry.h"
#include "dlgddeop.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNstestApp

BEGIN_MESSAGE_MAP(CNstestApp, CWinApp)
	//{{AFX_MSG_MAP(CNstestApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_DDE_OPTIONS, OnDdeOptions)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNstestApp construction

CNstestApp::CNstestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNstestApp object

CNstestApp NEAR theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.
static const CLSID BASED_CODE clsid =
{ 0x68784100, 0x59f6, 0x11ce, { 0x8c, 0xe4, 0x0, 0x20, 0xaf, 0x18, 0xf9, 0x5 } };

/////////////////////////////////////////////////////////////////////////////
// CNstestApp initialization

BOOL CNstestApp::InitInstance()
{
	//	Initialize DDEML
	if(DdeInitialize(&CDDEObject::m_dwidInst, NstestDdeCallBack, APPCLASS_STANDARD, 0ul))
	{
		AfxMessageBox(IDS_DDE_INIT_FAILED);
		CDDEObject::m_dwidInst = 0ul;
		return FALSE;
	}

	// Initialize OLE 2.0 libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // Set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_NSTESTTYPE,
		RUNTIME_CLASS(CNstestDoc),
		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
		RUNTIME_CLASS(CNstestView));
	pDocTemplate->SetContainerInfo(IDR_NSTESTTYPE_CNTR_IP);
	pDocTemplate->SetServerInfo(
		IDR_NSTESTTYPE_SRVR_EMB, IDR_NSTESTTYPE_SRVR_IP,
		RUNTIME_CLASS(CInPlaceFrame));
	AddDocTemplate(pDocTemplate);

	// Connect the COleTemplateServer to the document template.
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template.
	m_server.ConnectTemplate(clsid, pDocTemplate, FALSE);

	// Register all OLE server factories as running.  This enables the
	//  OLE 2.0 libraries to create objects from other applications.
	COleTemplateServer::RegisterAll();
		// Note: MDI applications register all server objects without regard
		//  to the /Embedding or /Automation on the command line.

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// enable file manager drag/drop and DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes();

	// Parse the command line to see if launched as OLE server
	// Go ahead and show ourselves on RunAutomated() as we'll need to display
	//		our output from automation in our own window.
	TRACE("Command line is %s.\n", m_lpCmdLine);
	BOOL bEmbedded = RunEmbedded();
	BOOL bAutomated = RunAutomated();
	
	if (bEmbedded == FALSE && bAutomated == FALSE)
	{
		// When a server application is launched stand-alone, it is a good idea
		//  to update the system registry in case it has been damaged.
		m_server.UpdateRegistry(OAT_INPLACE_SERVER);
		COleObjectFactory::UpdateRegistryAll();
	}

	// simple command line parsing
	// If we're run automated (/Automation, or /Embedded), we want to do special handling.
	TRACE("Checking automated status.\n");
	if(bAutomated == FALSE && bEmbedded == FALSE)	{
		if (m_lpCmdLine[0] == '\0')
		{
			// create a new (empty) document
			OnFileNew();
		}
		else
		{
			// open an existing document
			OpenDocumentFile(m_lpCmdLine);
		}
	}
	else	{
		TRACE("Running automated, perhaps embedded.\n");
	
		//	User will still be in control of the applciation.
		TRACE("Setting user controls to be on.\n");
		AfxOleSetUserCtrl(TRUE);
		
		//	No document to open, this will happen later.
		//	Also, we don't want to show our main frame window.
		//	Automation code will show the window when and if
		//		the need arises.
		return(TRUE);
	}

	m_pMainWnd->DragAcceptFiles();
	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

    //  Get all our options initialized.
    m_bHex = GetProfileInt("DDE Options", "Hex", FALSE);

	TRACE("Finished InitInstance.\n");
	return TRUE;
}

int CNstestApp::ExitInstance()	{
	//	Off with the DDEML.
	BOOL bUned = TRUE;
	if(CDDEObject::m_dwidInst != 0ul)	{
		DdeNameService(CDDEObject::m_dwidInst, NULL, NULL, DNS_UNREGISTER);
		bUned = DdeUninitialize(CDDEObject::m_dwidInst);
	}
	
	if(bUned)	{	
		return(CWinApp::ExitInstance());
	}
	else	{
		CWinApp::ExitInstance();
		return(-1);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CNstestApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CNstestApp commands

CDocument *CNstestApp::OpenDocumentNew()	{
	//	Create a new document from the template.
	//	If you have multiple document templates, now would be a good time
	//		to figure out which one will be used.
	CDocTemplate *pTemplate = (CDocTemplate *)m_templateList.GetHead();
	
	//	Make sure we're visible to the rest of the world.
	
	//	This will create a new document.
	return(pTemplate->OpenDocumentFile(NULL));
}
void CNstestApp::OnDdeOptions() 
{
    //  Query the user for DDE options they want to use,
    //      and simply refresh our flag if they don't hit
    //      cancel.
    CDlgDDEOptions dlgOpt;

    dlgOpt.m_bUseHex = m_bHex;

    if(dlgOpt.DoModal() == IDOK)    {
        //  They may have changed something.
        m_bHex = dlgOpt.m_bUseHex;

        //  Save it.
        WriteProfileInt("DDE Options", "Hex", m_bHex);
    }
}
